Index: uspace/srv/locsrv/locsrv.c
===================================================================
--- uspace/srv/locsrv/locsrv.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/locsrv/locsrv.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -184,7 +184,5 @@
 	assert(fibril_mutex_is_locked(&services_list_mutex));
 	
-	list_foreach(namespaces_list, item) {
-		loc_namespace_t *namespace =
-		    list_get_instance(item, loc_namespace_t, namespaces);
+	list_foreach(namespaces_list, namespaces, loc_namespace_t, namespace) {
 		if (str_cmp(namespace->name, name) == 0)
 			return namespace;
@@ -203,7 +201,5 @@
 	assert(fibril_mutex_is_locked(&services_list_mutex));
 	
-	list_foreach(namespaces_list, item) {
-		loc_namespace_t *namespace =
-		    list_get_instance(item, loc_namespace_t, namespaces);
+	list_foreach(namespaces_list, namespaces, loc_namespace_t, namespace) {
 		if (namespace->id == id)
 			return namespace;
@@ -219,7 +215,5 @@
 	assert(fibril_mutex_is_locked(&services_list_mutex));
 	
-	list_foreach(services_list, item) {
-		loc_service_t *service =
-		    list_get_instance(item, loc_service_t, services);
+	list_foreach(services_list, services, loc_service_t, service) {
 		if ((str_cmp(service->namespace->name, ns_name) == 0)
 		    && (str_cmp(service->name, name) == 0))
@@ -239,7 +233,5 @@
 	assert(fibril_mutex_is_locked(&services_list_mutex));
 	
-	list_foreach(services_list, item) {
-		loc_service_t *service =
-		    list_get_instance(item, loc_service_t, services);
+	list_foreach(services_list, services, loc_service_t, service) {
 		if (service->id == id)
 			return service;
@@ -889,9 +881,5 @@
 	fibril_mutex_lock(&callback_sess_mutex);
 	
-	list_foreach(callback_sess_list, link) {
-		cb_sess_t *cb_sess;
-		
-		cb_sess = list_get_instance(link, cb_sess_t, cb_sess_list);
-		
+	list_foreach(callback_sess_list, cb_sess_list, cb_sess_t, cb_sess) {
 		async_exch_t *exch = async_exchange_begin(cb_sess->sess);
 		async_msg_0(exch, LOC_EVENT_CAT_CHANGE);
@@ -1050,8 +1038,5 @@
 	
 	size_t pos = 0;
-	list_foreach(namespaces_list, item) {
-		loc_namespace_t *namespace =
-		    list_get_instance(item, loc_namespace_t, namespaces);
-		
+	list_foreach(namespaces_list, namespaces, loc_namespace_t, namespace) {
 		desc[pos].id = namespace->id;
 		str_cpy(desc[pos].name, LOC_NAME_MAXLEN, namespace->name);
@@ -1114,8 +1099,5 @@
 	
 	size_t pos = 0;
-	list_foreach(services_list, item) {
-		loc_service_t *service =
-		    list_get_instance(item, loc_service_t, services);
-		
+	list_foreach(services_list, services, loc_service_t, service) {
 		if (service->namespace == namespace) {
 			desc[pos].id = service->id;
Index: uspace/srv/logger/logs.c
===================================================================
--- uspace/srv/logger/logs.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/logger/logs.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -44,6 +44,5 @@
 static logger_log_t *find_log_by_name_and_parent_no_list_lock(const char *name, logger_log_t *parent)
 {
-	list_foreach(log_list, it) {
-		logger_log_t *log = list_get_instance(it, logger_log_t, link);
+	list_foreach(log_list, link, logger_log_t, log) {
 		if ((parent == log->parent) && (str_cmp(log->name, name) == 0))
 			return log;
@@ -148,6 +147,5 @@
 
 	fibril_mutex_lock(&log_list_guard);
-	list_foreach(log_list, it) {
-		logger_log_t *log = list_get_instance(it, logger_log_t, link);
+	list_foreach(log_list, link, logger_log_t, log) {
 		if (str_cmp(log->full_name, name) == 0) {
 			fibril_mutex_lock(&log->guard);
@@ -166,6 +164,5 @@
 
 	fibril_mutex_lock(&log_list_guard);
-	list_foreach(log_list, it) {
-		logger_log_t *log = list_get_instance(it, logger_log_t, link);
+	list_foreach(log_list, link, logger_log_t, log) {
 		if ((sysarg_t) log == id) {
 			fibril_mutex_lock(&log->guard);
Index: uspace/srv/net/dhcp/Makefile
===================================================================
--- uspace/srv/net/dhcp/Makefile	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
+++ uspace/srv/net/dhcp/Makefile	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -0,0 +1,35 @@
+#
+# Copyright (c) 2013 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../../..
+BINARY = dhcp
+
+SOURCES = \
+	dhcp.c 
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/srv/net/dhcp/dhcp.c
===================================================================
--- uspace/srv/net/dhcp/dhcp.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
+++ uspace/srv/net/dhcp/dhcp.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -0,0 +1,491 @@
+/*
+ * Copyright (c) 2013 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup dhcp
+ * @{
+ */
+/**
+ * @file
+ * @brief DHCP client
+ */
+
+#include <bitops.h>
+#include <inet/addr.h>
+#include <inet/dnsr.h>
+#include <inet/inetcfg.h>
+#include <loc.h>
+#include <net/in.h>
+#include <net/inet.h>
+#include <net/socket.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+#include "dhcp_std.h"
+
+#define NAME "dhcp"
+
+#define MAX_MSG_SIZE 1024
+
+static int transport_fd = -1;
+static addr48_t mac_addr;
+static uint8_t msgbuf[MAX_MSG_SIZE];
+
+typedef struct {
+	/** Message type */
+	enum dhcp_msg_type msg_type;
+	/** Offered address */
+	inet_naddr_t oaddr;
+	/** Server address */
+	inet_addr_t srv_addr;
+	/** Router address */
+	inet_addr_t router;
+	/** DNS server */
+	inet_addr_t dns_server;
+} dhcp_offer_t;
+
+/** Decode subnet mask into subnet prefix length. */
+static int subnet_mask_decode(uint32_t mask, int *bits)
+{
+	int zbits;
+	uint32_t nmask;
+
+	if (mask == 0xffffffff) {
+		*bits = 32;
+		return EOK;
+	}
+
+	zbits = 1 + fnzb32(mask ^ 0xffffffff);
+	nmask = BIT_RRANGE(uint32_t, zbits);
+
+	if ((mask ^ nmask) != 0xffffffff) {
+		/* The mask is not in the form 1**n,0**m */
+		return EINVAL;
+	}
+
+	*bits = 32 - zbits;
+	return EOK;
+}
+
+static uint32_t dhcp_uint32_decode(uint8_t *data)
+{
+	return
+	    ((uint32_t)data[0] << 24) |
+	    ((uint32_t)data[1] << 16) |
+	    ((uint32_t)data[2] << 8) |
+	    ((uint32_t)data[3]);
+}
+
+static int dhcp_send(void *msg, size_t size)
+{
+	struct sockaddr_in addr;
+	int rc;
+
+	addr.sin_family = AF_INET;
+	addr.sin_port = htons(dhcp_server_port);
+	addr.sin_addr.s_addr = htonl(addr32_broadcast_all_hosts);
+
+	rc = sendto(transport_fd, msg, size, 0,
+	    (struct sockaddr *)&addr, sizeof(addr));
+	if (rc != EOK) {
+		printf("Sending failed\n");
+		return rc;
+	}
+
+	return EOK;
+}
+
+static int dhcp_send_discover(void)
+{
+	dhcp_hdr_t *hdr = (dhcp_hdr_t *)msgbuf;
+	uint8_t *opt = msgbuf + sizeof(dhcp_hdr_t);
+
+	memset(msgbuf, 0, MAX_MSG_SIZE);
+	hdr->op = op_bootrequest;
+	hdr->htype = 1; /* AHRD_ETHERNET */
+	hdr->hlen = sizeof(addr48_t);
+	hdr->xid = host2uint32_t_be(42);
+	hdr->flags = flag_broadcast;
+
+	addr48(mac_addr, hdr->chaddr);
+	hdr->opt_magic = host2uint32_t_be(dhcp_opt_magic);
+
+	opt[0] = opt_msg_type;
+	opt[1] = 1;
+	opt[2] = msg_dhcpdiscover;
+	opt[3] = opt_end;
+
+	return dhcp_send(msgbuf, sizeof(dhcp_hdr_t) + 4);
+}
+
+static int dhcp_recv_msg(void **rmsg, size_t *rsize)
+{
+	struct sockaddr_in src_addr;
+	socklen_t src_addr_size;
+	size_t recv_size;
+	int rc;
+
+	src_addr_size = sizeof(src_addr);
+	rc = recvfrom(transport_fd, msgbuf, MAX_MSG_SIZE, 0,
+	    (struct sockaddr *)&src_addr, &src_addr_size);
+	if (rc < 0) {
+		printf("recvfrom failed (%d)\n", rc);
+		return rc;
+	}
+
+	recv_size = (size_t)rc;
+	*rmsg = msgbuf;
+	*rsize = recv_size;
+
+	return EOK;
+}
+
+static int dhcp_send_request(dhcp_offer_t *offer)
+{
+	dhcp_hdr_t *hdr = (dhcp_hdr_t *)msgbuf;
+	uint8_t *opt = msgbuf + sizeof(dhcp_hdr_t);
+	size_t i;
+
+	memset(msgbuf, 0, MAX_MSG_SIZE);
+	hdr->op = op_bootrequest;
+	hdr->htype = 1; /* AHRD_ETHERNET */
+	hdr->hlen = 6;
+	hdr->xid = host2uint32_t_be(42);
+	hdr->flags = flag_broadcast;
+	hdr->ciaddr = host2uint32_t_be(offer->oaddr.addr);
+	addr48(mac_addr, hdr->chaddr);
+	hdr->opt_magic = host2uint32_t_be(dhcp_opt_magic);
+
+	i = 0;
+
+	opt[i++] = opt_msg_type;
+	opt[i++] = 1;
+	opt[i++] = msg_dhcprequest;
+
+	opt[i++] = opt_req_ip_addr;
+	opt[i++] = 4;
+	opt[i++] = offer->oaddr.addr >> 24;
+	opt[i++] = (offer->oaddr.addr >> 16) & 0xff;
+	opt[i++] = (offer->oaddr.addr >> 8) & 0xff;
+	opt[i++] = offer->oaddr.addr & 0xff;
+
+	opt[i++] = opt_server_id;
+	opt[i++] = 4;
+	opt[i++] = offer->srv_addr.addr >> 24;
+	opt[i++] = (offer->srv_addr.addr >> 16) & 0xff;
+	opt[i++] = (offer->srv_addr.addr >> 8) & 0xff;
+	opt[i++] = offer->srv_addr.addr & 0xff;
+
+	opt[i++] = opt_end;
+
+	return dhcp_send(msgbuf, sizeof(dhcp_hdr_t) + i);
+}
+
+static int dhcp_recv_reply(void *msg, size_t size, dhcp_offer_t *offer)
+{
+	dhcp_hdr_t *hdr = (dhcp_hdr_t *)msg;
+	inet_addr_t yiaddr;
+	inet_addr_t siaddr;
+	inet_addr_t giaddr;
+	uint32_t subnet_mask;
+	bool have_subnet_mask = false;
+	bool have_server_id = false;
+	int subnet_bits;
+	char *saddr;
+	uint8_t opt_type, opt_len;
+	uint8_t *msgb;
+	int rc;
+	size_t i;
+
+	printf("Receive reply\n");
+	memset(offer, 0, sizeof(*offer));
+
+	yiaddr.family = AF_INET;
+	yiaddr.addr = uint32_t_be2host(hdr->yiaddr);
+	rc = inet_addr_format(&yiaddr, &saddr);
+	if (rc != EOK)
+		return rc;
+
+	printf("Your IP address: %s\n", saddr);
+	free(saddr);
+
+	siaddr.family = AF_INET;
+	siaddr.addr = uint32_t_be2host(hdr->siaddr);
+	rc = inet_addr_format(&siaddr, &saddr);
+	if (rc != EOK)
+		return rc;
+
+	printf("Next server IP address: %s\n", saddr);
+	free(saddr);
+
+	giaddr.family = AF_INET;
+	giaddr.addr = uint32_t_be2host(hdr->giaddr);
+	rc = inet_addr_format(&giaddr, &saddr);
+	if (rc != EOK)
+		return rc;
+
+	printf("Relay agent IP address: %s\n", saddr);
+	free(saddr);
+
+	offer->oaddr.family = AF_INET;
+	offer->oaddr.addr = yiaddr.addr;
+
+	msgb = (uint8_t *)msg;
+
+	i = sizeof(dhcp_hdr_t);
+	while (i < size) {
+		opt_type = msgb[i++];
+
+		if (opt_type == opt_pad)
+			continue;
+		if (opt_type == opt_end)
+			break;
+
+		if (i >= size)
+			return EINVAL;
+
+		opt_len = msgb[i++];
+
+		if (i + opt_len > size)
+			return EINVAL;
+
+		switch (opt_type) {
+		case opt_subnet_mask:
+			if (opt_len != 4)
+				return EINVAL;
+			subnet_mask = dhcp_uint32_decode(&msgb[i]);
+			rc = subnet_mask_decode(subnet_mask, &subnet_bits);
+			if (rc != EOK)
+				return EINVAL;
+			offer->oaddr.prefix = subnet_bits;
+			have_subnet_mask = true;
+			break;
+		case opt_msg_type:
+			if (opt_len != 1)
+				return EINVAL;
+			offer->msg_type = msgb[i];
+			break;
+		case opt_server_id:
+			if (opt_len != 4)
+				return EINVAL;
+			offer->srv_addr.family = AF_INET;
+			offer->srv_addr.addr = dhcp_uint32_decode(&msgb[i]);
+			have_server_id = true;
+			break;
+		case opt_router:
+			if (opt_len != 4)
+				return EINVAL;
+			offer->router.family = AF_INET;
+			offer->router.addr = dhcp_uint32_decode(&msgb[i]);
+			break;
+		case opt_dns_server:
+			if (opt_len != 4)
+				return EINVAL;
+			offer->dns_server.family = AF_INET;
+			offer->dns_server.addr = dhcp_uint32_decode(&msgb[i]);
+			break;
+		case opt_end:
+			break;
+		default:
+			break;
+		}
+
+		/* Advance to the next option */
+		i = i + opt_len;
+	}
+
+	if (!have_server_id) {
+		printf("Missing server ID option.\n");
+		return rc;
+	}
+
+	if (!have_subnet_mask) {
+		printf("Missing subnet mask option.\n");
+		return rc;
+	}
+
+	rc = inet_naddr_format(&offer->oaddr, &saddr);
+	if (rc != EOK)
+		return rc;
+
+	printf("Offered network address: %s\n", saddr);
+	free(saddr);
+
+	if (offer->router.addr != 0) {
+		rc = inet_addr_format(&offer->router, &saddr);
+		if (rc != EOK)
+			return rc;
+
+		printf("Router address: %s\n", saddr);
+		free(saddr);
+	}
+
+	if (offer->dns_server.addr != 0) {
+		rc = inet_addr_format(&offer->dns_server, &saddr);
+		if (rc != EOK)
+			return rc;
+
+		printf("DNS server: %s\n", saddr);
+		free(saddr);
+	}
+
+	return EOK;
+}
+
+static int dhcp_cfg_create(service_id_t iplink, dhcp_offer_t *offer)
+{
+	int rc;
+	service_id_t addr_id;
+	service_id_t sroute_id;
+	inet_naddr_t defr;
+
+	rc = inetcfg_addr_create_static("dhcp4a", &offer->oaddr, iplink,
+	    &addr_id);
+	if (rc != EOK) {
+		printf("Error creating IP address %s (%d)\n", "dhcp4a", rc);
+		return rc;
+	}
+
+	if (offer->router.addr != 0) {
+		defr.family = AF_INET;
+		defr.addr = 0;
+		defr.prefix = 0;
+
+		rc = inetcfg_sroute_create("dhcpdef", &defr, &offer->router, &sroute_id);
+		if (rc != EOK) {
+			printf("Error creating default route %s (%d).\n", "dhcpdef",
+			    rc);
+			return rc;
+		}
+	}
+
+	if (offer->dns_server.addr != 0) {
+		rc = dnsr_set_srvaddr(&offer->dns_server);
+		if (rc != EOK) {
+			printf("%s: Failed setting nameserver address (%d))\n",
+			    NAME, rc);
+			return rc;
+		}
+	}
+
+	return EOK;
+}
+
+int main(int argc, char *argv[])
+{
+	int fd;
+	struct sockaddr_in laddr;
+	void *msg;
+	service_id_t iplink;
+	size_t msg_size;
+	dhcp_offer_t offer;
+	int rc;
+
+	if (argc < 2) {
+		printf("syntax: %s <ip-link>\n", NAME);
+		return 1;
+	}
+
+	rc = inetcfg_init();
+	if (rc != EOK) {
+		printf("Failed contacting inet configuration service.\n");
+		return 1;
+	}
+
+	rc = loc_service_get_id(argv[1], &iplink, 0);
+	if (rc != EOK) {
+		printf("Failed resolving service '%s'.\n", argv[1]);
+		return 1;
+	}
+
+	/* XXX Determine MAC address automatically */
+	mac_addr[0] = 0xaa;
+	mac_addr[1] = 0xde;
+	mac_addr[2] = 0xad;
+	mac_addr[3] = 0xbe;
+	mac_addr[4] = 0xef;
+	mac_addr[5] = 0xfe;
+
+	laddr.sin_family = AF_INET;
+	laddr.sin_port = htons(dhcp_client_port);
+	laddr.sin_addr.s_addr = INADDR_ANY;
+
+	fd = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);
+	if (fd < 0)
+		return 1;
+
+	printf("Bind socket.\n");
+	rc = bind(fd, (struct sockaddr *)&laddr, sizeof(laddr));
+	if (rc != EOK)
+		return 1;
+
+	printf("Set socket options\n");
+	rc = setsockopt(fd, SOL_SOCKET, SO_IPLINK, &iplink, sizeof(iplink));
+	if (rc != EOK)
+		return 1;
+
+	transport_fd = fd;
+
+	printf("Send DHCPDISCOVER\n");
+	rc = dhcp_send_discover();
+	if (rc != EOK)
+		return 1;
+
+	rc = dhcp_recv_msg(&msg, &msg_size);
+	if (rc != EOK)
+		return 1;
+
+	printf("Received %zu bytes\n", msg_size);
+
+	rc = dhcp_recv_reply(msg, msg_size, &offer);
+	if (rc != EOK)
+		return 1;
+
+	rc = dhcp_send_request(&offer);
+	if (rc != EOK)
+		return 1;
+
+	rc = dhcp_recv_msg(&msg, &msg_size);
+	if (rc != EOK)
+		return 1;
+
+	printf("Received %zu bytes\n", msg_size);
+
+	rc = dhcp_recv_reply(msg, msg_size, &offer);
+	if (rc != EOK)
+		return 1;
+
+	rc = dhcp_cfg_create(iplink, &offer);
+	if (rc != EOK)
+		return 1;
+
+	closesocket(fd);
+	return 0;
+}
+
+/** @}
+ */
Index: uspace/srv/net/dhcp/dhcp_std.h
===================================================================
--- uspace/srv/net/dhcp/dhcp_std.h	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
+++ uspace/srv/net/dhcp/dhcp_std.h	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -0,0 +1,130 @@
+/*
+ * Copyright (c) 2013 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup dhcp
+ * @{
+ */
+/**
+ * @file
+ * @brief DHCP standard definitions
+ */
+
+#ifndef DHCP_STD_H
+#define DHCP_STD_H
+
+#include <stdint.h>
+
+enum {
+	dhcp_server_port = 67,
+	dhcp_client_port = 68
+};
+
+/** Fixed part of DHCP message */
+typedef struct {
+	/** Message op code */
+	uint8_t op;
+	/** Hardware address type */
+	uint8_t htype;
+	/** Hardware address length */
+	uint8_t hlen;
+	/** Hops */
+	uint8_t hops;
+	/** Transaction ID */
+	uint32_t xid;
+	/** Seconds elapsed since client began address acqusition or renewal */
+	uint16_t secs;
+	/** Flags */
+	uint16_t flags;
+	/** Client IP address */
+	uint32_t ciaddr;
+	/** Your (client) IP address */
+	uint32_t yiaddr;
+	/** IP address of next server */
+	uint32_t siaddr;
+	/** Relay agent IP address */
+	uint32_t giaddr;
+	/** Client hardware address */
+	uint8_t chaddr[16];
+	/** Server host name */
+	uint8_t sname[64];
+	/** Boot file name */
+	uint8_t file[128];
+	/** Magic cookie signalling the start of DHCP options */
+	uint32_t opt_magic;
+} dhcp_hdr_t;
+
+/** Values for dhcp_hdr_t.op */
+enum dhcp_op {
+	op_bootrequest = 1,
+	op_bootreply = 2
+};
+
+/** Values for dhcp_hdr_t.flags */
+enum dhcp_flags {
+	flag_broadcast = 0x80
+};
+
+/** Magic cookie signalling the start of DHCP options field */
+enum {
+	dhcp_opt_magic = (99 << 24) | (130 << 16) | (83 << 8) | 99
+};
+
+enum dhcp_option_code {
+	/** Padding */
+	opt_pad = 0,
+	/** Subnet mask */
+	opt_subnet_mask = 1,
+	/** Router IP address */
+	opt_router = 3,
+	/** Domain name server */
+	opt_dns_server = 6,
+	/** Requested IP address */
+	opt_req_ip_addr = 50,
+	/** DHCP message type */
+	opt_msg_type = 53,
+	/** Server identifier */
+	opt_server_id = 54,
+	/** End */
+	opt_end = 255
+};
+
+/** DHCP message type */
+enum dhcp_msg_type {
+	msg_dhcpdiscover = 1,
+	msg_dhcpoffer = 2,
+	msg_dhcprequest = 3,
+	msg_dhcpdecline = 4,
+	msg_dhcpack = 5,
+	msg_dhcpnak = 6,
+	msg_dhcprelease = 7
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/net/dnsrsrv/dns_msg.c
===================================================================
--- uspace/srv/net/dnsrsrv/dns_msg.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/net/dnsrsrv/dns_msg.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -510,6 +510,5 @@
 	size = sizeof(dns_header_t);
 
-	list_foreach(msg->question, link) {
-		dns_question_t *q = list_get_instance(link, dns_question_t, msg);
+	list_foreach(msg->question, msg, dns_question_t, q) {
 		rc = dns_question_encode(q, NULL, 0, &q_size);
 		if (rc != EOK)
@@ -526,6 +525,5 @@
 	di = sizeof(dns_header_t);
 
-	list_foreach(msg->question, link) {
-		dns_question_t *q = list_get_instance(link, dns_question_t, msg);
+	list_foreach(msg->question, msg, dns_question_t, q) {
 		rc = dns_question_encode(q, data + di, size - di, &q_size);
 		if (rc != EOK) {
Index: uspace/srv/net/dnsrsrv/dnsrsrv.c
===================================================================
--- uspace/srv/net/dnsrsrv/dnsrsrv.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/net/dnsrsrv/dnsrsrv.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -60,5 +60,5 @@
 	rc = transport_init();
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed initializing tarnsport.");
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed initializing transport.");
 		return EIO;
 	}
Index: uspace/srv/net/dnsrsrv/query.c
===================================================================
--- uspace/srv/net/dnsrsrv/query.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/net/dnsrsrv/query.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -99,7 +99,5 @@
 	}
 	
-	list_foreach(amsg->answer, link) {
-		dns_rr_t *rr = list_get_instance(link, dns_rr_t, msg);
-		
+	list_foreach(amsg->answer, msg, dns_rr_t, rr) {
 		log_msg(LOG_DEFAULT, LVL_DEBUG, " - '%s' %u/%u, dsize %zu",
 		    rr->name, rr->rtype, rr->rclass, rr->rdata_size);
Index: uspace/srv/net/dnsrsrv/transport.c
===================================================================
--- uspace/srv/net/dnsrsrv/transport.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/net/dnsrsrv/transport.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -158,7 +158,5 @@
 	assert(fibril_mutex_is_locked(&treq_lock));
 
-	list_foreach(treq_list, link) {
-		trans_req_t *treq = list_get_instance(link, trans_req_t, lreq);
-
+	list_foreach(treq_list, lreq, trans_req_t, treq) {
 		if (treq->req->id == resp->id) {
 			/* Match */
Index: uspace/srv/net/ethip/arp.c
===================================================================
--- uspace/srv/net/ethip/arp.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/net/ethip/arp.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -98,4 +98,10 @@
     addr48_t mac_addr)
 {
+	/* Broadcast address */
+	if (ip_addr == addr32_broadcast_all_hosts) {
+		addr48(addr48_broadcast, mac_addr);
+		return EOK;
+	}
+
 	int rc = atrans_lookup(ip_addr, mac_addr);
 	if (rc == EOK)
Index: uspace/srv/net/ethip/atrans.c
===================================================================
--- uspace/srv/net/ethip/atrans.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/net/ethip/atrans.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -51,8 +51,5 @@
 static ethip_atrans_t *atrans_find(addr32_t ip_addr)
 {
-	list_foreach(atrans_list, link) {
-		ethip_atrans_t *atrans = list_get_instance(link,
-		    ethip_atrans_t, atrans_list);
-
+	list_foreach(atrans_list, atrans_list, ethip_atrans_t, atrans) {
 		if (atrans->ip_addr == ip_addr)
 			return atrans;
Index: uspace/srv/net/ethip/ethip_nic.c
===================================================================
--- uspace/srv/net/ethip/ethip_nic.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/net/ethip/ethip_nic.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -84,7 +84,5 @@
 		already_known = false;
 
-		list_foreach(ethip_nic_list, link) {
-			ethip_nic_t *nic = list_get_instance(link,
-			    ethip_nic_t, link);
+		list_foreach(ethip_nic_list, link, ethip_nic_t, nic) {
 			if (nic->svc_id == svcs[i]) {
 				already_known = true;
@@ -201,4 +199,11 @@
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Error activating NIC '%s'.",
 		    nic->svc_name);
+		goto error;
+	}
+
+	rc = nic_broadcast_set_mode(nic->sess, NIC_BROADCAST_ACCEPTED);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Error enabling "
+		    "reception of broadcast frames on '%s'.", nic->svc_name);
 		goto error;
 	}
@@ -313,8 +318,6 @@
 	    (unsigned) iplink_sid);
 
-	list_foreach(ethip_nic_list, link) {
+	list_foreach(ethip_nic_list, link, ethip_nic_t, nic) {
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_nic_find_by_iplink_sid - element");
-		ethip_nic_t *nic = list_get_instance(link, ethip_nic_t, link);
-
 		if (nic->iplink_sid == iplink_sid) {
 			log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_nic_find_by_iplink_sid - found %p", nic);
@@ -350,8 +353,5 @@
 	size_t count = 0;
 	
-	list_foreach(nic->addr_list, link) {
-		ethip_link_addr_t *laddr = list_get_instance(link,
-		    ethip_link_addr_t, link);
-		
+	list_foreach(nic->addr_list, link, ethip_link_addr_t, laddr) {
 		uint16_t af = inet_addr_get(&laddr->addr, NULL, NULL);
 		if (af == AF_INET6)
@@ -371,14 +371,11 @@
 	size_t i = 0;
 	
-	list_foreach(nic->addr_list, link) {
-		assert(i < count);
-		
-		ethip_link_addr_t *laddr = list_get_instance(link,
-		    ethip_link_addr_t, link);
-		
+	list_foreach(nic->addr_list, link, ethip_link_addr_t, laddr) {
 		addr128_t v6;
 		uint16_t af = inet_addr_get(&laddr->addr, NULL, &v6);
 		if (af != AF_INET6)
 			continue;
+		
+		assert(i < count);
 		
 		addr48_t mac;
@@ -444,8 +441,5 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_nic_addr_find()");
 	
-	list_foreach(nic->addr_list, link) {
-		ethip_link_addr_t *laddr = list_get_instance(link,
-		    ethip_link_addr_t, link);
-		
+	list_foreach(nic->addr_list, link, ethip_link_addr_t, laddr) {
 		if (inet_addr_compare(addr, &laddr->addr))
 			return laddr;
Index: uspace/srv/net/inetsrv/addrobj.c
===================================================================
--- uspace/srv/net/inetsrv/addrobj.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/net/inetsrv/addrobj.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -115,8 +115,5 @@
 	fibril_mutex_lock(&addr_list_lock);
 	
-	list_foreach(addr_list, link) {
-		inet_addrobj_t *naddr = list_get_instance(link,
-		    inet_addrobj_t, addr_list);
-		
+	list_foreach(addr_list, addr_list, inet_addrobj_t, naddr) {
 		switch (find) {
 		case iaf_net:
@@ -158,8 +155,5 @@
 	    name, ilink->svc_name);
 
-	list_foreach(addr_list, link) {
-		inet_addrobj_t *naddr = list_get_instance(link,
-		    inet_addrobj_t, addr_list);
-
+	list_foreach(addr_list, addr_list, inet_addrobj_t, naddr) {
 		if (naddr->ilink == ilink && str_cmp(naddr->name, name) == 0) {
 			log_msg(LOG_DEFAULT, LVL_DEBUG, "inet_addrobj_find_by_name_locked: found %p",
@@ -206,8 +200,5 @@
 	fibril_mutex_lock(&addr_list_lock);
 
-	list_foreach(addr_list, link) {
-		inet_addrobj_t *naddr = list_get_instance(link,
-		    inet_addrobj_t, addr_list);
-
+	list_foreach(addr_list, addr_list, inet_addrobj_t, naddr) {
 		if (naddr->id == id) {
 			fibril_mutex_unlock(&addr_list_lock);
@@ -277,8 +268,5 @@
 
 	i = 0;
-	list_foreach(addr_list, link) {
-		inet_addrobj_t *addr = list_get_instance(link,
-		    inet_addrobj_t, addr_list);
-
+	list_foreach(addr_list, addr_list, inet_addrobj_t, addr) {
 		id_list[i++] = addr->id;
 	}
Index: uspace/srv/net/inetsrv/icmp.c
===================================================================
--- uspace/srv/net/inetsrv/icmp.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/net/inetsrv/icmp.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -105,4 +105,5 @@
 	reply->checksum = host2uint16_t_be(checksum);
 
+	rdgram.iplink = 0;
 	rdgram.src = dgram->dest;
 	rdgram.dest = dgram->src;
@@ -171,4 +172,5 @@
 	inet_addr_set(sdu->dest, &dgram.dest);
 	
+	dgram.iplink = 0;
 	dgram.tos = ICMP_TOS;
 	dgram.data = rdata;
Index: uspace/srv/net/inetsrv/inet_link.c
===================================================================
--- uspace/srv/net/inetsrv/inet_link.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/net/inetsrv/inet_link.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -140,7 +140,5 @@
 		already_known = false;
 
-		list_foreach(inet_link_list, ilink_link) {
-			inet_link_t *ilink = list_get_instance(ilink_link,
-			    inet_link_t, link_list);
+		list_foreach(inet_link_list, link_list, inet_link_t, ilink) {
 			if (ilink->svc_id == svcs[i]) {
 				already_known = true;
@@ -237,4 +235,5 @@
 	inet_addrobj_t *addr = NULL;
 	
+	/* XXX FIXME Cannot rely on loopback being the first IP link service!! */
 	if (first_link) {
 		addr = inet_addrobj_new();
@@ -242,13 +241,4 @@
 		inet_naddr(&addr->naddr, 127, 0, 0, 1, 24);
 		first_link = false;
-	} else {
-		/*
-		 * FIXME
-		 * Setting static IPv4 address for testing purposes:
-		 * 10.0.2.15/24
-		 */
-		addr = inet_addrobj_new();
-		
-		inet_naddr(&addr->naddr, 10, 0, 2, 15, 24);
 	}
 	
@@ -492,8 +482,5 @@
 	fibril_mutex_lock(&inet_discovery_lock);
 
-	list_foreach(inet_link_list, elem) {
-		inet_link_t *ilink = list_get_instance(elem, inet_link_t,
-		    link_list);
-
+	list_foreach(inet_link_list, link_list, inet_link_t, ilink) {
 		if (ilink->svc_id == link_id) {
 			fibril_mutex_unlock(&inet_discovery_lock);
Index: uspace/srv/net/inetsrv/inetping.c
===================================================================
--- uspace/srv/net/inetsrv/inetping.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/net/inetsrv/inetping.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -82,8 +82,5 @@
 	fibril_mutex_lock(&client_list_lock);
 	
-	list_foreach(client_list, link) {
-		inetping_client_t *client = list_get_instance(link,
-		    inetping_client_t, client_list);
-		
+	list_foreach(client_list, client_list, inetping_client_t, client) {
 		if (client->ident == ident) {
 			fibril_mutex_unlock(&client_list_lock);
Index: uspace/srv/net/inetsrv/inetping6.c
===================================================================
--- uspace/srv/net/inetsrv/inetping6.c	(revision 7f84430205518d0134dd9a2c5d6d22a909150b5f)
+++ uspace/srv/net/inetsrv/inetping6.c	(revision 67fbd5e822922b8167b911f3d04b3e871f887781)
@@ -82,8 +82,5 @@
 	fibril_mutex_lock(&client_list_lock);
 	
-	list_foreach(client_list, link) {
-		inetping6_client_t *client = list_get_instance(link,
-		    inetping6_client_t, client_list);
-		
+	list_foreach(client_list, client_list, inetping6_client_t, client) {
 		if (client->ident == ident) {
 			fibril_mutex_unlock(&client_list_lock);
